/* File:     PaeCamera.h
 * Author:   PAE
 * Date:     18.03.2006
 * Modified: 23.03.2006
 *
 * Purpose: Headerdatei zur Klasse PaeTerrain
 */

#ifndef PAECAMERA_HEADER
#define PAECAMERA_HEADER

#include <iostream>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <math.h>

using namespace std;


class PaeCamera{
  private:
    GLfloat pos[3]; //wo ist die kamera
    GLfloat  up[3]; //wo ist oben; laenge des vektors = 1
    GLfloat dir[3]; //wo schaut die kamera hin; laenge des vektors = 1
    GLfloat rig[3]; //wo geht's nach rechts; laenge des vektors = 1

  public:
    PaeCamera(void);//standardkonstruktor
    void SetCam(void);//kamera wird in die welt gesetzt
    void RotateDir(float angle);//die kamera rotiert um die z-achse; angle muss in rad eingegeben werden
    //positiv : nach links, negativ : nach rechts
    void Rotate(float length);//die kamera rotiert nach vorne unten/oben
    //positiov : nach oben, negativ : nach unten
    void MoveUp(float length);//die kamera wird um length nach oben in richtung up verschoben
    //positiv : nach oben, negativ : nach unten
    void MoveForward(float length);//die kamera wird um length nach vorne in richtung dir verschoben
    //positiv : nach unten, negativ : nach oben
    void MoveSide(float length);//die kamera wird zur seite hin verschoben
    //positiv : nach links, negativ : nach rechts

    void StatusPrint(void);     // Prints cam parameters to screen

    void Pitch(float length);  //neue Rotationsmethode
    void Yaw(float length);  //neue Rotationsmethode
    void Roll(float length);  //neue Rotationsmethode

	void SetPosition(float x, float y, float z);
};

#endif // PAECAMERA_HEADER

