/* 
 * File:    main.c
 * Author:  PAE
 * Date:    18.03.2006
 *
 * Purpose: Rahmenprogramm fuer simulation
 */

#define MAIN

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

#include "PaeTerrain.h"
#include "PaeCamera.h"
#include "PaeSheep.h"
#include "PaeSimulator.h"

#include "wrapper.h"

using namespace std;


int main(int argc, char **argv) {

  simulator = new PaeSimulator();

  srand(time(NULL));

  simulator->cam->SetPosition(45,42,1);

  simulator->wor->terr->ScaleTerrain(-5.0, 5.0);
  simulator->wor->terr->ReBuildNormals();

  simulator->Init(argc, argv);

  glutDisplayFunc(WrapDisplay);
  glutKeyboardFunc(WrapKey);
  glutReshapeFunc(WrapReshape);
  glutSpecialFunc(WrapSpecialKey);

  glutTimerFunc(50, WrapTimer, 0);

  glutMainLoop();
};






